/** For test only => see 'package.json' file for use of 'dotenv' */
// import dotenv from "dotenv"; // Install it in '"dependencies"'...
// Load data from '.env' file:
// dotenv.config();
// console.log(JSON.stringify(process.env)); // Caution: sensitive data may be displayed...
/** End of test */

export const corsMethods = process.env.CORS_METHODS;
export const corsUrl = process.env.CORS_URL;
export const database = { // MongoDB Atlas (https://www.mongodb.com/cloud/atlas)
    name: process.env.DB_NAME || 'New_York_City_Penitentiary_database',
    password: process.env.DB_PASSWORD || 'Unknown password => No app.!',
    user: process.env.DB_USER || 'FB'
};
console.assert(process.env.NODE_ENV === 'DEBUG' || process.env.NODE_ENV === 'RELEASE'); // 'DEBUG' or 'RELEASE' values expected...
export const port = process.env.PORT || 1963; // If 'PORT' env. variable is unset then exposes API at port '1963'...
// console.log(process.env); // Caution: sensitive data may be displayed...
