import CriminalCase, {CriminalCaseModel} from '../schemes/CriminalCase';

export const Get_collection_name = () => CriminalCaseModel.collection.name;

export default class CriminalCaseDAO {
    public static Create(criminal_case: CriminalCase): Promise<CriminalCase> {
        return CriminalCaseModel.create(criminal_case);
    }

    public static Delete(criminal_case: CriminalCase): Promise<any>;
    public static Delete(criminal_case_number: string, jurisdiction_name: string): Promise<any>;
    public static Delete(x: CriminalCase | string, jurisdiction_name?: string) {
        return typeof x === "string" ?
            CriminalCaseModel.deleteOne({criminal_case_number: x, jurisdiction_name: jurisdiction_name}).exec() :
            CriminalCaseModel.deleteOne({
                criminal_case_number: x.criminal_case_number,
                jurisdiction_name: jurisdiction_name
            }).exec();
    }

    public static GetCriminalCase(criminal_case_number: string, jurisdiction_name: string, id = false): Promise<CriminalCase | null> {
        return CriminalCaseModel.findOne({
            criminal_case_number: criminal_case_number,
            jurisdiction_name: jurisdiction_name
        })
            .select({_id: id, __v: false})
            .lean()
            .exec();
    }

    public static GetCriminalCases(): Promise<CriminalCase[]> {
        return CriminalCaseModel.find()
            .select({_id: false, __v: false})
            .lean()
            .exec();
    }

    public static Update(criminal_case: CriminalCase): Promise<CriminalCase | any> {
        return CriminalCaseModel.updateOne({
                criminal_case_number: criminal_case.criminal_case_number,
                jurisdiction_name: criminal_case.jurisdiction_name
            },
            {$set: {...criminal_case}})
            .select({_id: false, __v: false})
            .exec();
    }
}
