import JudicialDecision, {JudicialDecisionModel} from "../../persistence/schemes/JudicialDecision";

export const Get_collection_name = () => JudicialDecisionModel.collection.name;

export default class JudicialDecisionDAO {

    public static Create(judicial_decision: JudicialDecision, prisoner: any): Promise<JudicialDecision> {
        judicial_decision.prisoner = prisoner;
        return JudicialDecisionModel.create(judicial_decision);
    }

    public static Delete(judicial_decision: JudicialDecision): Promise<any>;
    public static Delete(decision_type_number: string, prison_file_number: string, date_of_decision: Date): Promise<any>;
    public static Delete(x: JudicialDecision | string, prison_file_number?: string, date_of_decision?: Date) {
        return typeof x === "string" ?
            JudicialDecisionModel.deleteOne({
                decision_type_number: x,
                prison_file_number: prison_file_number,
                date_of_decision: date_of_decision
            }).exec() :
            JudicialDecisionModel.deleteOne({
                decision_type_number: x.decision_type_number,
                prison_file_number: x.prisoner.prison_file_number,
                date_of_decision: x.date_of_decision
            }).exec();
    }

    public static GetJudicialDecision(decision_type_number: string, prisoner: any, date_of_decision: Date, id = false): Promise<JudicialDecision | null> {
        return JudicialDecisionModel.findOne({
            decision_type_number: decision_type_number,
            prisoner: prisoner,
            date_of_decision: date_of_decision
        })
            .select({_id: id, __v: false})
            .lean()
            .exec();
    }

    public static GetJudicialDecisions(): Promise<JudicialDecision[]> {
        return JudicialDecisionModel.find()
            .select({_id: false, __v: false})
            .lean()
            .exec();
    }

    public static Update(judicial_decision: JudicialDecision): Promise<JudicialDecision | any> {
        return JudicialDecisionModel.updateOne({
            decision_type_number: judicial_decision.decision_type_number,
            prison_file_number: judicial_decision.prisoner.prison_file_number,
            date_of_decision: judicial_decision.date_of_decision
        }, {$set: {...judicial_decision}})
            .select({_id: false, __v: false})
            .exec();
    }
}
