import Motive, {MotiveModel} from '../schemes/Motive';

export const Get_collection_name = () => MotiveModel.collection.name;

export default class MotiveDAO {
    public static Create(motive: Motive): Promise<Motive> {
        return MotiveModel.create(motive);
    }

    // Overloads => multiple signatures without implementation:
    public static Delete(motive: Motive): Promise<any>;
    public static Delete(motive_number: string): Promise<any>;
    // Implementation by means of union types:
    public static Delete(x: Motive | string) {
        return typeof x === "string" ?
            MotiveModel.deleteOne({motive_number: x}).exec() :
            MotiveModel.deleteOne({motive_number: x.motive_number}).exec();
    }

    public static GetMotive(motive_number: string, id = false): Promise<Motive | null> {
        return MotiveModel.findOne({motive_number: motive_number})
            .select({_id: id, __v: false}) // Excluded fields...
            .lean()
            .exec();
    }

    public static GetMotives(): Promise<Motive[]> {
        return MotiveModel.find()
            .select({_id: false, __v: false}) // Excluded fields...
            .lean()
            .exec();
    }

    public static Update(motive: Motive): Promise<Motive | any> {
        return MotiveModel.updateOne({motive_number: motive.motive_number}, {$set: {...motive}})
            .select('-_id -__v') // Excluded fields...
            .exec();
    }
}
