import Prisoner, {PrisonerModel} from '../schemes/Prisoner';

export const Get_collection_name = () => 'offenses';

export default class OffenseDAO {
    public static Create(offense: any, prisoner: any): Promise<any> {
        // '$addToSet' guarantees no duplicate instead of '$push':
        return PrisonerModel.updateOne({_id: prisoner}, {$addToSet: {offense: offense}})
            .select({_id: 0, __v: 0})
            .exec();
    }

    public static Delete(offense: any, prisoner: any): Promise<any> {
        return PrisonerModel.updateOne({_id: prisoner}, {$pull: {offense: offense}})
            .select({_id: 0, __v: 0})
            .exec();
    }

    public static GetOffenses(prisoner: any): Promise<Prisoner | null> {
        return PrisonerModel.findOne({_id: prisoner}).populate({path: 'offense'/*, match : { jurisdiction_name : 'Nantes' } */})
            .select({_id: 0, __v: 0, prison_file_number: 0, date_of_incarceration: 0, main: 0, motive: 0})
            .lean()
            .exec();
    }
}
