import Prisoner, {PrisonerModel} from '../schemes/Prisoner';

export const Get_collection_name = () => PrisonerModel.collection.name;

export default class PrisonerDAO {
    public static Create(prisoner: Prisoner, main: any, motive: any): Promise<Prisoner> {
        prisoner.main = main;
        prisoner.motive = motive;
        // UML '{subsets offense}' constraint:
        prisoner.offense = new Array(main);
        return PrisonerModel.create(prisoner);
    }

    public static Delete(prisoner: Prisoner): Promise<any>;
    public static Delete(prison_file_number: string): Promise<any>;
    public static Delete(x: Prisoner | string) {
        return typeof x === "string" ?
            PrisonerModel.deleteOne({prison_file_number: x}).exec() :
            PrisonerModel.deleteOne({prison_file_number: x.prison_file_number}).exec();
    }

    public static GetPrisoner(prison_file_number: string, id = false): Promise<Prisoner | null> {
        return PrisonerModel.findOne({prison_file_number: prison_file_number})
            .select({_id: id, __v: false})
            .lean()
            .exec();
    }

    public static GetPrisoners(): Promise<Prisoner[]> {
        return PrisonerModel.find()
            .select({_id: 0, __v: 0})
            .lean()
            .exec();
    }

    public static Update(prisoner: Prisoner, main: any, motive: any): Promise<Prisoner | any> {
        prisoner.main = main;
        prisoner.motive = motive;
        // UML '{subsets offense}' constraint:
        prisoner.offense.push(main);
        return PrisonerModel.updateOne({prison_file_number: prisoner.prison_file_number}, {$set: {...prisoner}})
            .select({_id: 0, __v: 0})
            .exec();
    }
}
