import mongoose from "mongoose";
import {database} from '../Configuration';
// https://mongoosejs.com/docs/connections.html#connections
const Database_URI = `mongodb+srv://${database.user}:${database.password}@web-scraping-98xi5.mongodb.net/${database.name}?retryWrites=true&w=majority`;
mongoose.connect(Database_URI, {
    // List of options: https://mongodb.github.io/node-mongodb-native/5.4/interfaces/MongoClientOptions.html
    appName: "New-York City Penitentiary",
    connectTimeoutMS: 10000, // Give up initial connection after 10 seconds...
    socketTimeoutMS: 45000 // Close socket after 45 seconds of inactivity...
})
    .then(() => console.log('MongoDB connection succeeds...'))
    .catch(error => console.error('MongoDB connection failed: ' + error.message));
// When successfully connected:
mongoose.connection.on('connected', () => {
    console.log('New York City Penitentiary activated from: ' + Database_URI);
})
mongoose.connection.on('disconnected', () => {
    console.log('New York City Penitentiary disactivated from: ' + Database_URI);
})
mongoose.connection.on('error', error => {
    console.error(error.message);
})
