import express from 'express';

import {
    Get_collection_name as Criminal_case_API,
    router as criminal_case_router
} from './micro_services/CriminalCase_CRUD';
import {Get_collection_name as JudicialDecision_API, router as judicial_decision_router} from './micro_services/JudicialDecision_CRUD';
import {Get_collection_name as Motive_API, router as motive_router} from './micro_services/Motive_CRUD';
import {Get_collection_name as Offense_API, router as offense_router} from './micro_services/Offense_CRUD';
import {Get_collection_name as Prisoner_API, router as prisoner_router} from './micro_services/Prisoner_CRUD';
import {router as under_remand_router} from './use_cases/Under_remand';
// CRUD routes:
export const router = express.Router();
router.use('/' + Criminal_case_API(), criminal_case_router);
router.use('/' + JudicialDecision_API(), judicial_decision_router);
router.use('/' + Motive_API(), motive_router);
router.use('/' + Offense_API(), offense_router);
router.use('/' + Prisoner_API(), prisoner_router);
// Use case routes:
router.use('/' + 'Incarcerate', prisoner_router);
router.use('/' + 'Take_conviction_decision', judicial_decision_router);
router.use('/' + 'Take_final_discharge_decision', judicial_decision_router);
router.use('/' + 'Take_shortened_sentence_decision', judicial_decision_router);
router.use('/' + 'Under_remand', under_remand_router);
